/* meme chose que Fibo1Bis mais en passant par les arguments de la fonction main */
public class Fibo1Ter {

    public static int fibo(int n) {
        int u_n = 1;
        if(n == 2)
            u_n = 2;
        int u_n_moins_deux = 1;
        int u_n_moins_un = 2;

        for(int i = 3; i <= n; i++) {
            u_n = u_n_moins_deux + u_n_moins_un;
            u_n_moins_deux = u_n_moins_un;
            u_n_moins_un = u_n;
        }
        return u_n;
    }

    public static void main(String[] args) {
        /* 
            on impose un argument a l'execution. 
            Si le nombre d'arguments n'est pas egal a un, on affiche un message d'erreur avec un mode d'emploi 
        */
        if(args.length != 1) {
            System.out.println("Error, invalid arguments. Expected: execute with command 'java Fibo1Ter int', example: 'java Fibo1Ter 6'");
            System.exit(1);
        }
        int n = Integer.parseInt(args[0]); // cast de la chaine de caractere lue en une valeur entiere, erreur si on n'a pas rentre un nombre entier 
        System.out.println(fibo(n));
    }

}
